<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\PenggunaanbarangModel;
use App\Http\Models\StgpelniscmmoiintModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PenggunaanbarangService extends BaseService
{
	/**
     PenggunaanbarangService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PenggunaanbarangModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationVoyageKode()->joinRelationLocationId()->joinRelationAccountId()->getQuery()
			->select([
				"penggunaanbarang.id as id",
				"penggunaanbarang.miNumber as miNumber",
				"penggunaanbarang.kapalId",
				"locationId.id as locationId",
				"locationId.namaLokasi as namaLokasi",
				"accountId.namaAccount",
				"penggunaanbarang.tglPenggunaan as tglPenggunaan",
				"penggunaanbarang.jlhBarang as jlhBarang",
				"penggunaanbarang.destinationAccount as destinationAccount",
				"penggunaanbarang.voyageKode as voyageKode",
				"penggunaanbarang.voyageStart as voyageStart",
				"penggunaanbarang.voyageEnd as voyageEnd",
				"voyageKode.voyageName as voyageName"
			])
			->whereIn("penggunaanbarang.locationId", $auth->arrLokasi);

		$input = $request->all();
		if (isset($input["q"])) {
			$arrKeys = explode("||", $input["q"]);
			foreach ($arrKeys as $key) {
				$arrKey = explode(":", $key);
				if (isset($arrKey[0]) && $arrKey[1] && $arrKey[0] == "namaItem" && !empty($arrKey[0])) {
					$namaItem = $arrKey[1];
					$this->model->getQuery()->whereIn('penggunaanbarang.miNumber', function ($query) use ($namaItem) {
						$query->select('miNumber')->from('itempenggunaanbarang_')->leftjoin("item", "item.id", "=", "itempenggunaanbarang_.itemId")
							->where("item.namaItem", "ILIKE", "%" . $namaItem . "%")
							->orWhere("item.part_number", "ILIKE", "%" . $namaItem . "%")
							->orWhere("item.deskripsi", "ILIKE", "%" . $namaItem . "%");
					});
				}
			}
		}

		$this->model->getQuery()->whereIn("penggunaanbarang.locationId", $auth->arrLokasi);

		$this->model->getQuery()->whereIn("penggunaanbarang.miNumber", function ($query) use ($auth) {
			$query->select('itempenggunaanbarang_.miNumber')
				->from('itempenggunaanbarang_')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempenggunaanbarang_.itemId");
					$join->on("item.kapalId", "=", "penggunaanbarang.kapalId");
				})
				// "item.id", "=", "itempenggunaanbarang.itemId")
				->whereIn("item.type_id", $auth->arrCategory);
		});

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("penggunaanbarang.kapalId", "=", $auth->kapalId);
		}

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("penggunaanbarang.date_updated", "desc");
		}

		$this->model->paging()->filter()->sorting();
		$lists = $this->model->paging()->getPaging();

		foreach ($lists["rows"]  as $idx => $list) {
			$lists["rows"][$idx]->item = (new ItempenggunaanbarangService())->showOneBasedOnPenggunaanBarang($request, $list);
		}
		return $lists;
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PenggunaanbarangModel
	 */
	public function show($id)
	{
		$model =	$this->model->joinRelationVoyageKode()->joinRelationKapalId()->joinRelationAccountId()->joinRelationLocationId()->getQuery()
			->select(["penggunaanbarang.*", "accountId.namaAccount", "kapalId.namaKapal", "voyageKode.voyageName as voyageName", "locationId.namaLokasi as namaLokasi"])
			->where("penggunaanbarang.id", "=", $id)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PenggunaanbarangModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jlhBarang = 0;
		if (isset($input["itemID"])) {
			$jlhBarang = array_sum($input["quantity"]);
		}
		$input["approverId"] = 0;
		$input["transactionType"] = 1;
		$input["jlhBarang"] = $jlhBarang;

		$transactionBrg = new PenggunaanbarangModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PenggunaanbarangModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$penggunaanbarang = PenggunaanbarangModel::find($id);
		// $penggunaanbarang->fill($input);
		$penggunaanbarang->jlhBarang = $input["jlhBarang"];
		if (!$penggunaanbarang->save()) {
			throw new \Exception();
		}
		return $penggunaanbarang;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("penggunaanbarang"."miNumber", 9, 6)) AS "miNumber"')->where("penggunaanbarang.miNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->miNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function saveStaging($input)
	{
		$data = [];
		$dateNow = date("Y-m-d H:i:s");
		$totalLine = count($input["itemID"]);

		foreach ($input["itemID"] as $stokID => $itemID) {
			$data[] =  [
				/* "transaction_number" 		=> $input["miNumber"],
						"organization_id"				=> $input["kapalId"],
						"distribution_account_id"		=> $input["destinationAccount"],
						"transaction_date"				=> $input["tglPenggunaan"],
						"item_segment1" 				=> $itemID,
						// "subinventory_code" 			=> $input["lokasiId"][$stokID],
						"transaction_quantity"			=> $input["quantity"][$stokID] */

				"transaction_number"			=> $input["miNumber"],
				"organization_id"				=> $input["kapalId"],
				"subinventory_code"				=> $input["subinventory_code"]->namaLokasi,
				"inventory_item_id"				=> $itemID,
				"item_segment1"					=> $input["namaItem"][$stokID],
				"transaction_quantity"			=> $input["quantity"][$stokID],
				"transaction_date"				=> $input["tglPenggunaan"],
				"attribute2"					=> $input["lotNumber"][$stokID],
				"attribute14"					=> $input["jabatan"],
				"voyage_call"					=> $input["voyageKode"],
				"source_code"					=> "INV Issue",
				"process_flag"					=> 1,
				"transaction_mode"				=> 3,
				"lock_flag"						=> 2,
				"transaction_source_type_id"	=> 13,
				"transaction_action_id"			=> 27,

				"total_line"					=> $totalLine
			];
		}

		/* $stagingModel = new StgpelniscmmoiintModel();
		if(! $stagingModel->save($data)) {
			throw new \Exception();
		} */

		foreach ($data as $dat) {
			$stagingModel = new StgpelniscmmoiintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}

	public function updateQty($miNumber, $qty)
	{
		$penggunaanbarang = $this->model->getQuery()->where("miNumber", "=", $miNumber)->first();
		if (!$penggunaanbarang) {
			throw new \Exception();
		} else {
			$qty = $penggunaanbarang->jlhBarang + $qty;
			if ($qty >= 0) { } else {
				$qty = 0;
			}
			$this->update($penggunaanbarang->id, ["jlhBarang" => $qty]);
		}
	}

	public function getItemPenggunaanBarangVoyage($itemID, $voyageID, $voyageFrom, $voyageTo)
	{
		$model = (new PenggunaanbarangModel())->joinRelationItempenggunaanbarangId()->getQuery()
			->where("itempenggunaanbarang_.itemId", "=", $itemID)
			->where("penggunaanbarang.voyageKode", "=", $voyageID)
			->where("penggunaanbarang.tglPenggunaan", ">=", $voyageFrom)
			->where("penggunaanbarang.tglPenggunaan", "<=", $voyageTo)
			->get();
		return $model;
	}

	public function getItemPenggunaanBarangBulan($itemID, $from, $to)
	{
		$model = (new PenggunaanbarangModel())->joinRelationItempenggunaanbarangId()->getQuery()
			->where("itempenggunaanbarang_.itemId", "=", $itemID)
			->where("penggunaanbarang.tglPenggunaan", ">=", $from)
			->where("penggunaanbarang.tglPenggunaan", "<=", $to)
			->get();
		return $model;
	}

	public function getSumPenggunaanBarang($itemID, $voyageID, $voyageFrom, $voyageTo)
	{
		$totalQty = 0;
		$model = $this->getItemPenggunaanBarangVoyage($itemID, $voyageID, $voyageFrom, $voyageTo);
		foreach ($model as $row) {
			$totalQty += $row->quantity;
		}
		return $totalQty;
	}
	public function getSumPenggunaanBarangBulan($itemID, $tahun, $bulan)
	{
		$from = $tahun . "-" . $bulan . "-01";
		$to = date("Y-m-t", strtotime($from));
		$totalQty = 0;
		$model = $this->getItemPenggunaanBarangBulan($itemID, $from, $to);
		foreach ($model as $row) {
			$totalQty += $row->quantity;
		}
		return $totalQty;
	}
}
